' Test of (simple) collision library
IMPORT "./examples/collision.bas"
IMPORT "./examples/keycodes.bas"

SCREEN (1024,700,"Collision Test")
radius = 40
x=screenwidth/2
y=screenheight/2
do
cls

if keystate (KEY_LEFT)=true then
    x=x-1
endif
if keystate (KEY_RIGHT)=true then
    x=x+1
endif
if keystate (KEY_UP)=true then
    y=y-1
endif
if keystate (KEY_DOWN)=true then
    y=y+1
endif

ink (255,255,0)
drawtext (0,0,"Move the yellow circle with cursor keys and press SPACE to go on!")
ink (0,0,255)
rectangle (200,200,300,280)
circle (600,500,80)
ink (255,255,0)
if CircleToBoxColl (x,y,radius,200,200,100,80) then ink (255,0,0)
if CircleColl (x,y,radius,600,500,80) then ink (255,0,0)

circle (x,y,radius)

sync
until (keystate (KEY_SPACE) = true)

rectw=60
recth=40
x=screenwidth/2
y=screenheight/2


do
cls

if keystate (KEY_LEFT)=true then
    x=x-1
endif
if keystate (KEY_RIGHT)=true then
    x=x+1
endif
if keystate (KEY_UP)=true then
    y=y-1
endif
if keystate (KEY_DOWN)=true then
    y=y+1
endif
ink (255,255,0)
drawtext (0,0,"Move the yellow rectangle with cursor keys or press ESC to quit!")
ink (0,0,255)
fillrectangle (200,200,280,250)

ink (255,255,0)
if BoxColl (x,y,rectw,recth,200,200,80,50) then ink (255,0,0)


rectangle (x,y,x+rectw,y+recth)

sync
until (keystate (KEY_ESC) = true) or (windowclosed=true)
end


