def BoxColl (x1,y1,w1,h1,x2,y2,w2,h2)

  if x2 + w2 < x1 then return false
  if x2 > x1 + w1 then return false

  if y2 + h2 < y1 then return false
  if y2 > y1 + h1 then return false

  return true
enddef

def CircleColl (x1, y1, r1 , x2, y2, r2, coffset)

  xdiff = x2 - x1  ' x plane difference
  ydiff = y2 - y1  ' y plane difference

  ' distance between the circles centres squared
  dcentre_sq = ydiff*ydiff + xdiff*xdiff

  ' calculate sum of radiuses squared
  r_sum_sq = r1 + r2  'square on seperate line, so
  r_sum_sq = r_sum_sq*r_sum_sq  ' dont recompute r1 + r2

  return  (dcentre_sq - r_sum_sq <= (coffset*coffset))
enddef

def CircleToBoxcoll (cx,cy,r ,x1,y1,w,h)
 testx=cx
 testy=cy
 x2=x1+w
 y2=y1+h
 if testx < x1 then
	testx = x1
 endif
 if testx > x2 then
	testx = x2
 endif
 if testy < y1 then
    testy = y1
 endif
 if testy > y2 then
	testy = y2
 endif
  return (cx - testx) * (cx - testx) + (cy - testy) * (cy - testy) < r * r
enddef

